<template>
    <div class="content-block">
      <div class="container">
        <div class="margin-top-50"></div>
        <div class="row">
          <div class="columns twelve central-column my-accounts">
            <div class="content" style="position: relative">
              <h3 class="main-header">Мои счета</h3>
              <template v-if="$store.getters.getAccountsStatus !== 'firstLoad'">
                  <div class="white-block">
                    <div class="padding">
                      <h3>Основной счет</h3>
                    </div>
                    <hr>
                    <div :class="{blinking: requestStatus === 'primary-is-changed'}">
                      <card :cardWithAttr="cardsWithAttr.find(({block}) => block === 'main')"></card>
                    </div>
                  </div>
                <div class="white-block">
                  <div class="padding">
                    <h3>Мои карты</h3>
                    <button @click="$modal.show('new-card')" class="header-button white">Привязать новую карту</button>
                  </div>
                  <hr>
                  <card v-for="cardWithAttr in cardsWithAttr.filter(({block}) => block === 'secondary')"
                        :key="cardWithAttr.card.id"
                        :cardWithAttr="cardWithAttr" ></card>
                </div>
                <div class="white-block">
                  <div class="padding">
                    <h3>Другие каналы выдачи</h3>
                    <button @click="$modal.show('new-wallet')" class="header-button white">Привязать новый кошелек</button>
                  </div>
                  <hr>
                  <card v-for="cardWithAttr in cardsWithAttr.filter(({block}) => block === 'additional')"
                        :key="cardWithAttr.card.id"
                        :cardWithAttr="cardWithAttr" ></card>
                </div>
              </template>
              <vuex-error-block :errors="['mainErrorBlock']"></vuex-error-block>
              <div ref="errorBlock"></div>
            </div>
          </div>
          <new-wallet></new-wallet>
          <new-card></new-card>
        </div>
      </div>
      <delete-account></delete-account>
    </div>
</template>

<script>
  import Card from '@/pages/MyAccounts/Card'
  import Loader from '@/base/Loader'
  import DeleteAccount from './DeleteAccount'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import NewWallet from '@/components/Modals/NewWallet'
  import NewCard from '@/components/Modals/NewCard'
  import {getImgFilename, getPaySystemText} from '@/utils/mappings/accounts'
  import {ACCOUNTS_SET_STATUS} from '@/store/mutation-types'
  import VuexErrorBlock from '@/components/Validators/VuexErrorBlock'

export default {
    name: 'my-accounts-index',
    data () {
      return {
      }
    },
    mixins: [
      ErrorHandleMixin
    ],
    components: {
      VuexErrorBlock,
      Card,
      Loader,
      DeleteAccount,
      NewWallet,
      NewCard,
    },
    computed: {
      cards: function () {
        return this.$store.getters.getAccounts
      },
      cardsWithAttr () {
        return this.cards.map((card) => (
          {
            card: card,
            block: card.main
              ? 'main'
              : card.type === 1
                ? 'secondary'
                : 'additional',
            editable: card.type === 1,
            deletable: !card.main && (getPaySystemText(card.type) === 'Карта' || getPaySystemText(card.type) === 'Яндекс кошелёк'),
            img: getImgFilename(card.type, card.description)
          }))
      },
      requestStatus () {
        return this.$store.getters.getAccountsStatus
      }
    },
    mounted () {
      this.$store.dispatch('ACCOUNTS_GET')
      this.$modal.show('card-delete')
    },
    beforeMount () {
      this.$store.commit(ACCOUNTS_SET_STATUS, 'firstLoad')
    }
  }
</script>

<style scoped>
  .padding {
    position: relative;
  }

  .header-button {
    margin: 0;
    margin-right: 0px;
    position: absolute;
    top: 15px;
    right: 30px;
  }

  .blinking {
    animation: blink .5s ease-in;
  }

  @keyframes blink {
    0% {
      background-color: #6ac651;
    }
    100% {
      background-color: #fff;
    }
  }
</style>
